From d784a519bd5a0f23937440a4ea28aad7e04c7690 Mon Sep 17 00:00:00 2001
From: "Konstantin K. Oblaukhov" <oblaukhov@sl.iae.nsk.su>
Date: Thu, 16 Mar 2023 15:36:10 +0700
Subject: [PATCH 06/13] Genlock for FD722v5.0

---
 forward-v4l2/forward-v4l2-fd722.c | 103 +++++++++++++++++++-----------
 forward-v4l2/forward-v4l2-fd922.c |   2 +
 forward/forward-core.c            |   1 +
 forward/forward-fd722.c           |  74 ++++++++++++++++++++-
 forward/forward-fd922.c           |   2 -
 forward/forward-si532x.c          |   4 +-
 forward/forward-si534x.c          |   8 +--
 include/fd722_reg.h               |  23 +++++++
 include/forward-pll.h             |   2 +-
 9 files changed, 171 insertions(+), 48 deletions(-)

diff --git a/forward-v4l2/forward-v4l2-fd722.c b/forward-v4l2/forward-v4l2-fd722.c
index d5f1809..d4c67b8 100644
--- a/forward-v4l2/forward-v4l2-fd722.c
+++ b/forward-v4l2/forward-v4l2-fd722.c
@@ -48,6 +48,7 @@
 
 #define FD722_YC_SWAP_REVISION 861
 #define FD722_ASI_PERIOD_REVISION 871
+#define FD722_IS_VERSION_5(ver) (((ver >> 16) & 0xF) >= 6)
 
 static void fd722_check_pll_configuration(struct forward_v4l2 *v4l2)
 {
@@ -669,17 +670,20 @@ static s64 fd722_clock_deviation(struct forward_v4l2 *v4l2)
 static s64 fd722_set_clock_deviation(struct forward_v4l2 *v4l2, s64 ppt)
 {
 	struct forward_dev *dev = v4l2->dev;
-	FD722_ClockDeviation dv;
-	u64 value = ((ppt < 0) ? -ppt : ppt) * 2818572288ULL / 1000000000000ULL;
-
-	dv.deviation = (value > 1290555) ? 1290555 : value;
-	dv.direction = (ppt < 0) ? 1 : 0;
+	if (FD722_IS_VERSION_5(dev->fw_version)) {
+		return v4l2->dev->pll->ops->tune(v4l2->dev->pll, ppt);
+	} else {
+		FD722_ClockDeviation dv;
+		u64 value = ((ppt < 0) ? -ppt : ppt) * 2818572288ULL / 1000000000000ULL;
 
-	FD722_ClockDeviation_W(dev->csr, dv);
+		dv.deviation = (value > 1290555) ? 1290555 : value;
+		dv.direction = (ppt < 0) ? 1 : 0;
 
-	value = dv.deviation * 1000000000000ULL / 2818572288ULL;
+		FD722_ClockDeviation_W(dev->csr, dv);
 
-	return (ppt < 0) ? -value : value;
+		value = dv.deviation * 1000000000000ULL / 2818572288ULL;
+		return (ppt < 0) ? -value : value;
+	}
 }
 
 static u32 fd722_io_timestamp(const struct forward_v4l2_io *io)
@@ -729,61 +733,88 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 	FD722_SyncGenerator sg = { 0 };
 	FD722_SyncGeneratorField sgf = { 0 };
 	struct forward_pll_mode *mode = NULL;
+	bool v5 = FD722_IS_VERSION_5(v4l2->dev->fw_version);
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
 		mode = pll->ops->find_mode(pll, 0, 0, false, 148500000, false);
 		pll->ops->switch_mode(pll, mode);
-		pll->ops->select_input(pll, 1, false, false);
+		if (v5)
+			pll->ops->select_input(pll, 0, true, false);
+		else
+			pll->ops->select_input(pll, 1, false, false);
 		pll->ops->calibrate(pll);
 	} else {
-		int pll_in_freq = 0;
+		int pll_pix_freq = 0;
+		int pll_h_freq = 0;
 		FD722_Genlock gl = FD722_Genlock_R(v4l2->dev->csr);
 
+		pll_h_freq = forward_v4l2_pixel_clock(t) / t->sdi.width;
 		if (src == V4L_FORWARD_GENLOCK_SRC_ANALOG) {
-			pll_in_freq = forward_v4l2_pixel_clock(t) / t->sdi.width;
 			gl.mode = (t->sdi.mode == FORWARD_SDI_MODE_SD_SDI) ? 1 : 0;
 		} else if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) ||
 			   (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
 			if ((t->sdi.mode == FORWARD_SDI_MODE_SD_SDI) ||
 			    (t->sdi.flags & FORWARD_SDI_TIMINGS_F_ASI))
-				pll_in_freq = 6750000;
+				pll_pix_freq = v5 ? 13500000 : 6750000;
 			else if (t->sdi.mode == FORWARD_SDI_MODE_HD_SDI)
-				pll_in_freq = 74250000;
+				pll_pix_freq = 74250000;
 			else if (t->sdi.mode == FORWARD_SDI_MODE_3G_SDI)
-				pll_in_freq = 148500000;
+				pll_pix_freq = 148500000;
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		mode = pll->ops->find_mode(pll, pll_in_freq, 0, t->sdi.m, 148500000, t->sdi.m);
+		mode = pll->ops->find_mode(pll, pll_pix_freq, pll_h_freq, t->sdi.m, 148500000,
+					   t->sdi.m);
 		if (!mode)
 			return -EINVAL;
 
 		FD722_Genlock_W(v4l2->dev->csr, gl);
 		pll->ops->switch_mode(pll, mode);
 
-		if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) || (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
-			// Hack to avoid PLL->IN->PLL loop stuck
-			FD722_VideoInCS cs;
-			int count = 0;
-
-			// Force Master clock
-			pll->ops->select_input(pll, 1, false, false);
+		if (v5) {
+			int input = 0;
+			switch (src) {
+			case V4L_FORWARD_GENLOCK_SRC_ANALOG:
+				input = 0;
+				break;
+			case V4L_FORWARD_GENLOCK_SRC_IN0:
+				input = 1;
+				break;
+			case V4L_FORWARD_GENLOCK_SRC_IN1:
+				input = 2;
+				break;
+			default:
+				input = 0;
+				break;
+			}
+			pll->ops->select_input(pll, input, false, false);
 			pll->ops->calibrate(pll);
-
-			// Wait for input
-			do {
-				msleep(100);
-				cs = FD722_VideoInCS_R(v4l2->dev->csr,
-						       (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 1 :
-											      0);
-				count++;
-			} while ((!cs.modeLocked) && (count < 100));
-
-			// Switch to input clock
-			pll->ops->select_input(pll, 0, false, true);
 		} else {
-			pll->ops->select_input(pll, 0, false, true);
-			pll->ops->calibrate(pll);
+			if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) ||
+			    (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
+				// Hack to avoid PLL->IN->PLL loop stuck
+				FD722_VideoInCS cs;
+				int count = 0;
+
+				// Force Master clock
+				pll->ops->select_input(pll, 1, false, false);
+				pll->ops->calibrate(pll);
+
+				// Wait for input
+				do {
+					msleep(100);
+					cs = FD722_VideoInCS_R(
+						v4l2->dev->csr,
+						(src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 1 : 0);
+					count++;
+				} while ((!cs.modeLocked) && (count < 100));
+
+				// Switch to input clock
+				pll->ops->select_input(pll, 0, false, true);
+			} else {
+				pll->ops->select_input(pll, 0, false, true);
+				pll->ops->calibrate(pll);
+			}
 		}
 	}
 
diff --git a/forward-v4l2/forward-v4l2-fd922.c b/forward-v4l2/forward-v4l2-fd922.c
index 937a738..f0acc00 100644
--- a/forward-v4l2/forward-v4l2-fd922.c
+++ b/forward-v4l2/forward-v4l2-fd922.c
@@ -765,6 +765,8 @@ bool fd922_genlock_sync_irq_info(const struct forward_v4l2_genlock *gl, int num,
 		ref_time = FD922_AnalogVSyncTime_R(v4l2->dev->csr).time;
 
 	*gl_offset = (s32)(sync_time - ref_time);
+	if (gl->timings.sdi.m)
+		*gl_offset = (s64)*gl_offset * 1000LL / 1001LL;
 
 	return true;
 }
diff --git a/forward/forward-core.c b/forward/forward-core.c
index f4bd17c..6ed978e 100644
--- a/forward/forward-core.c
+++ b/forward/forward-core.c
@@ -64,6 +64,7 @@ static const struct pci_device_id forward_pci_ids[] = {
 	{ PCI_DEVICE(0x1C1F, 0x001C), .driver_data = FORWARD_FD922 },
 	{ PCI_DEVICE(0x1C1F, 0x001F), .driver_data = FORWARD_FD940 },
 	{ PCI_DEVICE(0x1C1F, 0x0020), .driver_data = FORWARD_FD2110 },
+	{ PCI_DEVICE(0x1C1F, 0x0021), .driver_data = FORWARD_FD722 },
 	{},
 };
 
diff --git a/forward/forward-fd722.c b/forward/forward-fd722.c
index 6ce45b0..1e86574 100644
--- a/forward/forward-fd722.c
+++ b/forward/forward-fd722.c
@@ -22,6 +22,7 @@
 #include "forward-vdma.h"
 
 #include "forward-si532x.h"
+#include "forward-si534x.h"
 #include "fd722_reg.h"
 
 #include <linux/delay.h>
@@ -63,18 +64,85 @@ static bool fd722_i2c_xfer(struct forward_dev *dev, u8 bus, bool read, uint8_t a
 	return !i2c.cs && !i2c.nack;
 }
 
+static bool fd722_spi_xfer(struct forward_dev *dev, u8 bus, u8 *tx, int tx_bits, u8 *rx,
+			   int rx_bits)
+{
+	int bits = max(tx_bits, rx_bits);
+	int word_count = (bits - 1) / 16 + 1;
+	int last_word_bits = ((bits - 1) % 16) + 1;
+	bool last8 = last_word_bits <= 8;
+	int i;
+	FD722_SPI ctl;
+
+	ctl.bus = bus;
+	ctl.start = 0;
+	ctl.cs = 1;
+	FD722_SPI_W(dev->csr, ctl);
+
+	for (i = 0; i < word_count; i++) {
+		if (tx && ((i * 16) < tx_bits)) {
+			uint8_t cur_tx_bits = ((tx_bits - i * 16 - 1) % 16) + 1;
+			if (cur_tx_bits <= 8) {
+				ctl.data = tx[i * 2] << (16 - cur_tx_bits);
+			} else {
+				ctl.data = (tx[i * 2] << 8) | (tx[i * 2 + 1] << (16 - cur_tx_bits));
+			}
+		} else {
+			ctl.data = 0xFFFF;
+		}
+
+		ctl.bus = bus;
+		ctl.cs = 1;
+		ctl.start = 1;
+		ctl.bit8 = ((i == word_count - 1) && last8) ? 0 : 1;
+		FD722_SPI_W(dev->csr, ctl);
+
+		do {
+			ctl = FD722_SPI_R(dev->csr);
+		} while (ctl.start);
+
+		if (rx && ((i * 16) < rx_bits)) {
+			uint8_t cur_rx_bits = ((rx_bits - i * 16 - 1) % 16) + 1;
+			uint16_t data = ctl.data;
+			if (cur_rx_bits <= 8) {
+				rx[i * 2] = data & 0xFF;
+			} else {
+				rx[i * 2] = (data >> 8) & 0xFF;
+				rx[i * 2 + 1] = data & 0xFF;
+			}
+		}
+	}
+
+	ctl.bus = bus;
+	ctl.start = 0;
+	ctl.cs = 0;
+
+	FD722_SPI_W(dev->csr, ctl);
+
+	return true;
+}
+
 static int fd722_init(struct forward_dev *dev)
 {
-	dev->i2c_xfer = &fd722_i2c_xfer;
+	FD722_DynamicVersion v = FD722_DynamicVersion_R(dev->csr);
 
-	forward_si532x_init(dev, &dev->pll, 0, FD722_PLL_ADDRESS, 2);
+	if (v.minor >= 6) {
+		dev->spi_xfer = &fd722_spi_xfer;
+		forward_si534x_init(dev, &dev->pll, 1, 3);
+	} else {
+		dev->i2c_xfer = &fd722_i2c_xfer;
+		forward_si532x_init(dev, &dev->pll, 0, FD722_PLL_ADDRESS, 2);
+	}
 
 	return 0;
 }
 
 static void fd722_fini(struct forward_dev *dev)
 {
-	forward_si532x_fini(dev, &dev->pll);
+	if (((dev->fw_version >> 16) & 0xF) >= 6)
+		forward_si534x_fini(dev, &dev->pll);
+	else
+		forward_si532x_fini(dev, &dev->pll);
 }
 
 static void fd722_read_id(struct forward_dev *dev)
diff --git a/forward/forward-fd922.c b/forward/forward-fd922.c
index 9722575..0128a5d 100644
--- a/forward/forward-fd922.c
+++ b/forward/forward-fd922.c
@@ -81,8 +81,6 @@ static bool fd922_spi_xfer(struct forward_dev *dev, u8 bus, u8 *tx, int tx_bits,
 
 static int fd922_init(struct forward_dev *dev)
 {
-	struct forward_pll_mode *mode;
-
 	dev->spi_xfer = &fd922_spi_xfer;
 
 	forward_si534x_init(dev, &dev->pll, 4, 3);
diff --git a/forward/forward-si532x.c b/forward/forward-si532x.c
index 07f1c98..0a38051 100644
--- a/forward/forward-si532x.c
+++ b/forward/forward-si532x.c
@@ -218,9 +218,9 @@ static int si532x_select_input(struct forward_pll *pll, int input, bool master,
 	return 0;
 }
 
-static int si532x_tune(struct forward_pll *pll, s64 ppt)
+static s64 si532x_tune(struct forward_pll *pll, s64 ppt)
 {
-	return -ENOTSUPP;
+	return 0;
 }
 
 static void si532x_calibrate(struct forward_pll *pll)
diff --git a/forward/forward-si534x.c b/forward/forward-si534x.c
index c56f3b3..6cca68b 100644
--- a/forward/forward-si534x.c
+++ b/forward/forward-si534x.c
@@ -599,8 +599,8 @@ static struct forward_pll_mode *si534x_find_mode(struct forward_pll *pll, s64 in
 
 	for (i = 0; i < forward_si534x_modes_count; i++) {
 		const struct forward_si534x_mode *cur = &forward_si534x_modes[i];
-		if (((in_pix_freq < 0) || (cur->in_freq_p == in_pix_freq)) &&
-		    ((in_h_freq < 0) || (cur->in_freq_h == in_h_freq)) && (cur->in_m == in_m) &&
+		if (((in_pix_freq <= 0) || (cur->in_freq_p == in_pix_freq)) &&
+		    ((in_h_freq <= 0) || (cur->in_freq_h == in_h_freq)) && (cur->in_m == in_m) &&
 		    (cur->out_m == out_m)) {
 			return (struct forward_pll_mode *)cur;
 		}
@@ -699,7 +699,7 @@ static int si534x_select_input(struct forward_pll *pll, int input, bool master,
 	return 0;
 }
 
-static int si534x_tune(struct forward_pll *pll, s64 ppt)
+static s64 si534x_tune(struct forward_pll *pll, s64 ppt)
 {
 	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
 	u32 denom = 0xc8000000 + 0xc8000000LL * ppt / 1000000000000LL;
@@ -708,7 +708,7 @@ static int si534x_tune(struct forward_pll *pll, s64 ppt)
 	si534x_write_reg_32(si534x, 0x313, denom);
 	si534x_write_reg_32(si534x, 0x338, 2);
 
-	return 0;
+	return ppt;
 }
 
 static void si534x_calibrate(struct forward_pll *pll)
diff --git a/include/fd722_reg.h b/include/fd722_reg.h
index 91180cc..b19b7ad 100644
--- a/include/fd722_reg.h
+++ b/include/fd722_reg.h
@@ -102,6 +102,29 @@ FD722_VAuxMonitor __always_inline FD722_VAuxMonitor_R(uint32_t *csr)
 	return *((FD722_VAuxMonitor *)&r);
 }
 
+typedef struct _FD722_SPI {
+	uint32_t data : 16;
+	uint32_t _unused2316 : 8;
+	uint32_t cs : 1;
+	uint32_t bit8 : 1;
+	uint32_t start : 1;
+	uint32_t bus : 1;
+	uint32_t _unused3128 : 4;
+} __attribute__((packed)) FD722_SPI;
+
+#define FD722_SPI_A (0x86)
+
+FD722_SPI __always_inline FD722_SPI_R(uint32_t *csr)
+{
+	uint32_t r = __read_reg(csr, FD722_SPI_A);
+	return *((FD722_SPI *)&r);
+}
+
+void __always_inline FD722_SPI_W(uint32_t *csr, FD722_SPI v)
+{
+	__write_reg(csr, FD722_SPI_A, *((uint32_t *)&v));
+}
+
 typedef struct _FD722_I2C {
 	uint32_t data : 8;
 	uint32_t subAddress : 8;
diff --git a/include/forward-pll.h b/include/forward-pll.h
index 683f8f9..98a665e 100644
--- a/include/forward-pll.h
+++ b/include/forward-pll.h
@@ -37,7 +37,7 @@ struct forward_pll_ops {
 					      s64 in_h_freq, bool in_m, s64 out_freq, bool out_m);
 	int (*switch_mode)(struct forward_pll *pll, struct forward_pll_mode *mode);
 	int (*select_input)(struct forward_pll *pll, int input, bool master, bool autoswitch);
-	int (*tune)(struct forward_pll *pll, s64 ppt);
+	s64 (*tune)(struct forward_pll *pll, s64 ppt);
 	void (*calibrate)(struct forward_pll *pll);
 };
 
-- 
2.39.1


